<template>
  <vxe-modal
    resize
    v-model="showModal"
    :title="modalTitle"
    @hide="onHide"
    width="500px"
    show-maximize
    show-footer
    esc-closable
  >
    <el-form ref="formRef" :model="form" :rules="rules" inline label-width="110px">
      <el-row :gutter="10">
        <el-col :span="24">
          <el-form-item class="w-full" label="调解中心名称" prop="name">
            <el-input v-model="form.name" placeholder="请输入调解中心名称" />
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item class="w-full" label="调解中心编码" prop="code">
            <el-input v-model="form.code" placeholder="调解中心编码" />
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item class="w-full" label="负责人" prop="adminUser">
            <el-input v-model="form.adminUser" placeholder="负责人" />
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item class="w-full" label="负责人手机" prop="phone">
            <el-input v-model="form.phone" placeholder="负责人手机" />
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item class="w-full" label="状态" prop="status">
            <el-radio-group v-model="form.status">
              <el-radio value="enable">启用</el-radio>
              <el-radio value="disable">禁用</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <template #footer>
      <el-button type="default" @click="showModal = false">取消</el-button>
      <el-button :loading="loading" type="primary" @click="submitForm">提交</el-button>
    </template>
  </vxe-modal>
</template>

<script setup name="tenantFormModal">
  import { ref, computed } from 'vue';
  import { saveTenant } from '@/api/tenant';
  import { ElMessage } from 'element-plus';

  const emits = defineEmits(['success']);
  const currentTenant = ref(null);
  const showModal = ref(false);
  const formRef = ref(null);

  const isEdit = computed(() => !!currentTenant.value);
  const modalTitle = computed(() => (isEdit.value ? '编辑调解中心' : '新增调解中心'));

  const form = ref({
    name: '',
    code: '',
    adminUser: '',
    phone: '',
    status: 'enable',
  });
  const validatePhone = (rule, value, callback) => {
    const reg = /^1[3-9]\d{9}$/;
    if (!value) {
      callback(new Error('请输入负责人手机'));
    } else if (!reg.test(value)) {
      callback(new Error('请输入正确的手机号'));
    } else {
      callback();
    }
  };
  const rules = ref({
    name: { required: true, message: '请输入调解中心名称', trigger: 'blur' },
    code: { required: true, message: '请输入调解中心编码', trigger: 'blur' },
    adminUser: { required: true, message: '请输入负责人', trigger: 'blur' },
    phone: [
      { required: true, message: '请输入负责人手机', trigger: 'blur' },
      { validator: validatePhone, trigger: 'blur' }
    ]
  });

  const loading = ref(false);
  const submitForm = async () => {
    try {
      await formRef.value.validate();
      loading.value = true;

      await saveTenant(form.value);
      emits('success');
      ElMessage({
        type: 'success',
        message: isEdit.value ? '修改成功！' : '添加成功!',
        plain: true,
      });
      showModal.value = false;
    } catch {}
    loading.value = false;
  };
  const onHide = () => {
    form.value = {
      name: '',
      code: '',
      adminUser: '',
      phone: '',
      status: 'enable',
    };
    formRef.value.clearValidate();
    currentTenant.value = null;
  };
  const openModal = (role) => {
    role && (form.value = role);
    currentTenant.value = role;
    showModal.value = true;
  };

  defineExpose({
    openModal,
  });
</script>
